/**
 *  Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.apache.geronimo.samples.osgi.showmethemoney.web;

import java.io.PrintWriter;
import java.io.IOException;
import javax.servlet.ServletException;
import java.lang.reflect.Method;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import javax.annotation.Resource;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NameClassPair;
import javax.naming.NamingException;
import javax.naming.NamingEnumeration;
import javax.naming.Binding;
import javax.sql.DataSource;
import javax.sql.XADataSource;

import org.apache.geronimo.samples.osgi.showmethemoney.api.ShowMoneyService;
import org.apache.geronimo.samples.osgi.showmethemoney.web.util.ServiceUtil;

/**
 * Show me the money!
 *
 */
public class ShowMoneyServlet extends HttpServlet
{
    @Resource
    private BundleContext bundleContext;
    
    private DataSource dataSource= null;
    
    Connection conn = null;
    PreparedStatement stmt = null;
       
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
       PrintWriter pw = res.getWriter();       
       
       ServiceReference sr = bundleContext.getServiceReference(ShowMoneyService.class.getName());
       if (sr != null) {
           ShowMoneyService sm = (ShowMoneyService) bundleContext.getService(sr);
           pw.println(sm.startup()); 
           bundleContext.ungetService(sr);
       }
       
       try {
           InitialContext ctx = new InitialContext();
           Context ctx2 = (Context) ctx.lookup("osgi:service");
           ShowMoneyService sm = (ShowMoneyService)ctx2.lookup("org.apache.geronimo.samples.osgi.showmethemoney.api.ShowMoneyService");
           pw.println(sm.showmoney()); 
           
           //Just Show you how to use datasource service, currently geronimo 3.0 has no derby db porlet, when this porlet is enabled,should
           //update here.
           dataSource = (DataSource)ServiceUtil.getOSGIService(DataSource.class.getName(),"(osgi.jndi.service.name=jdbc/NoTxMoneyDataSource)");
           
           try {
conn = dataSource.getConnection();
/*
stmt = conn.prepareStatement("select * from customer");
ResultSet rs = stmt.executeQuery();

while (rs.next()){
    pw.println(rs.getString("name"));
} */

} catch (SQLException e) {
// TODO Auto-generated catch block
 pw.println(e.toString());
}
           
       } catch (NamingException e){
           pw.println(e.toString());
       }  
       finally {  
          try {
        //stmt.close();
conn.close();
} catch (SQLException e) {
// TODO Auto-generated catch block
e.printStackTrace();
}
}
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        doGet(req, res);
    }
}
